ace.define("ace/mode/sas_highlight_rules",["require","exports","module","ace/lib/oop","ace/mode/text_highlight_rules"],function(e,t,n){"use strict";var r=e("../lib/oop"),i=e("./text_highlight_rules").TextHighlightRules,s=function(){this.$rules={start:[{include:"#comments"},{token:["support.function.sas","text","entity.name.function.sas"],regex:"(proc)( )(\\w+)",caseInsensitive:!0},{token:["support.function.sas","text","constant.other.table-name.sas"],regex:"^(data)( )([^\\s]+)",caseInsensitive:!0},{token:["entity.other.attribute-name.sas","text","constant.other.library-name.sas","constant.other.table-name.sas"],regex:"\\b(data|out)(=)((?:\\w+\\.)?)(\\w*)\\b",caseInsensitive:!0},{token:"support.function.sas",regex:"\\bsort|run|quit|output\\b",caseInsensitive:!0},{token:"constant.numeric.sas",regex:"\\b\\d+(?:\\.\\d+)*\\b"},{token:"constant.sas",regex:"\\blow|high\\b"},{token:["keyword.other.sas","text","variable.other.sas"],regex:"\\b(by)( )([^\\s]+)\\b",caseInsensitive:!0},{token:["keyword.other.sas","text","variable.other.sas"],regex:"(keep|drop|retain|format|class|var)( )([\\w\\s]+)",caseInsensitive:!0},{token:["keyword.other.sas","text","constant.other.table-name.sas"],regex:"\\b(set|tables|merge)( )([\\w\\s]+)\\b",caseInsensitive:!0},{token:"keyword.control.sas",regex:"\\b(?:if|else|then|end)\\b"},{token:"keyword.other.order.sas",regex:"\\bdescending\\b",caseInsensitive:!0},{token:"keyword.other.sas",regex:"\\btitle\\b",caseInsensitive:!0},{token:"keyword.operator.star.sas",regex:"\\*"},{token:"keyword.operator.comparison.sas",regex:"\\b<|>|eq|ne\\b"},{token:"keyword.null.sas",regex:" \\. "},{token:"keyword.operator.math.sas",regex:"-|\\+|/"},{token:"support.function.aggregate.sas",regex:"\\b(?:avg|sum)(?=\\s*\\()",caseInsensitive:!0},{token:["constant.other.library-name.sas","text","constant.other.table-name.sas"],regex:"(\\w+?)(\\.)(\\w+)"},{token:"text",regex:"proc sas;",push:[{token:"text",regex:"quit;",next:"pop"},{include:"source.sas"}]},{include:"#strings"},{include:"#regexps"}],"#comments":[{token:["comment.line.asterisk.sas","punctuation.definition.comment.sas","comment.line.asterisk.sas"],regex:"^(\\s*)(\\*)(.*;\\s*$)"},{token:"punctuation.definition.comment.sas",regex:"/\\*",push:[{token:"punctuation.definition.comment.sas",regex:"\\*/",next:"pop"},{defaultToken:"comment.block.c"}]}],"#string_escape":[{token:"constant.character.escape.sas",regex:"\\\\."}],"#string_interpolation":[{token:["punctuation.definition.string.end.sas","string.interpolated.sas","string.interpolated.sas"],regex:"(#\\{)([^\\}]*)(\\})"}],"#strings":[{token:["punctuation.definition.string.begin.sas","string.quoted.single.sas","string.quoted.single.sas"],regex:"(')([^'\\\\]*)(')",comment:"this is faster than the next begin/end rule since sub-pattern will match till end-of-line and sas files tend to have very long lines."},{token:"punctuation.definition.string.begin.sas",regex:"'",push:[{token:"punctuation.definition.string.end.sas",regex:"'",next:"pop"},{include:"#string_escape"},{defaultToken:"string.quoted.single.sas"}]},{token:["punctuation.definition.string.begin.sas","string.quoted.other.backtick.sas","string.quoted.other.backtick.sas"],regex:"(`)([^`\\\\]*)(`)",comment:"this is faster than the next begin/end rule since sub-pattern will match till end-of-line and sas files tend to have very long lines."},{token:"punctuation.definition.string.begin.sas",regex:"`",push:[{token:"punctuation.definition.string.end.sas",regex:"`",next:"pop"},{include:"#string_escape"},{defaultToken:"string.quoted.other.backtick.sas"}]},{token:["punctuation.definition.string.begin.sas","string.quoted.double.sas","string.quoted.double.sas"],regex:'(")([^"#]*)(")',comment:"this is faster than the next begin/end rule since sub-pattern will match till end-of-line and sas files tend to have very long lines."},{token:"punctuation.definition.string.begin.sas",regex:'"',push:[{token:"punctuation.definition.string.end.sas",regex:'"',next:"pop"},{include:"#string_interpolation"},{defaultToken:"string.quoted.double.sas"}]},{token:"punctuation.definition.string.begin.sas",regex:"%\\{",push:[{token:"punctuation.definition.string.end.sas",regex:"\\}",next:"pop"},{include:"#string_interpolation"},{defaultToken:"string.other.quoted.brackets.sas"}]}]},this.normalizeRules()};s.metaData={fileTypes:["sas"],foldingStartMarker:"(proc|data|%macro).*;$",foldingStopMarker:"(run|quit|%mend);",name:"SAS",scopeName:"source.sas"},r.inherits(s,i),t.SASHighlightRules=s}),ace.define("ace/mode/folding/cstyle",["require","exports","module","ace/lib/oop","ace/range","ace/mode/folding/fold_mode"],function(e,t,n){"use strict";var r=e("../../lib/oop"),i=e("../../range").Range,s=e("./fold_mode").FoldMode,o=t.FoldMode=function(e){e&&(this.foldingStartMarker=new RegExp(this.foldingStartMarker.source.replace(/\|[^|]*?$/,"|"+e.start)),this.foldingStopMarker=new RegExp(this.foldingStopMarker.source.replace(/\|[^|]*?$/,"|"+e.end)))};r.inherits(o,s),function(){this.foldingStartMarker=/(\{|\[)[^\}\]]*$|^\s*(\/\*)/,this.foldingStopMarker=/^[^\[\{]*(\}|\])|^[\s\*]*(\*\/)/,this.singleLineBlockCommentRe=/^\s*(\/\*).*\*\/\s*$/,this.tripleStarBlockCommentRe=/^\s*(\/\*\*\*).*\*\/\s*$/,this.startRegionRe=/^\s*(\/\*|\/\/)#?region\b/,this._getFoldWidgetBase=this.getFoldWidget,this.getFoldWidget=function(e,t,n){var r=e.getLine(n);if(this.singleLineBlockCommentRe.test(r)&&!this.startRegionRe.test(r)&&!this.tripleStarBlockCommentRe.test(r))return"";var i=this._getFoldWidgetBase(e,t,n);return!i&&this.startRegionRe.test(r)?"start":i},this.getFoldWidgetRange=function(e,t,n,r){var i=e.getLine(n);if(this.startRegionRe.test(i))return this.getCommentRegionBlock(e,i,n);var s=i.match(this.foldingStartMarker);if(s){var o=s.index;if(s[1])return this.openingBracketBlock(e,s[1],n,o);var u=e.getCommentFoldRange(n,o+s[0].length,1);return u&&!u.isMultiLine()&&(r?u=this.getSectionRange(e,n):t!="all"&&(u=null)),u}if(t==="markbegin")return;var s=i.match(this.foldingStopMarker);if(s){var o=s.index+s[0].length;return s[1]?this.closingBracketBlock(e,s[1],n,o):e.getCommentFoldRange(n,o,-1)}},this.getSectionRange=function(e,t){var n=e.getLine(t),r=n.search(/\S/),s=t,o=n.length;t+=1;var u=t,a=e.getLength();while(++t<a){n=e.getLine(t);var f=n.search(/\S/);if(f===-1)continue;if(r>f)break;var l=this.getFoldWidgetRange(e,"all",t);if(l){if(l.start.row<=s)break;if(l.isMultiLine())t=l.end.row;else if(r==f)break}u=t}return new i(s,o,u,e.getLine(u).length)},this.getCommentRegionBlock=function(e,t,n){var r=t.search(/\s*$/),s=e.getLength(),o=n,u=/^\s*(?:\/\*|\/\/|--)#?(end)?region\b/,a=1;while(++n<s){t=e.getLine(n);var f=u.exec(t);if(!f)continue;f[1]?a--:a++;if(!a)break}var l=n;if(l>o)return new i(o,r,l,t.length)}}.call(o.prototype)}),ace.define("ace/mode/sas",["require","exports","module","ace/lib/oop","ace/mode/text","ace/mode/sas_highlight_rules","ace/mode/folding/cstyle"],function(e,t,n){"use strict";var r=e("../lib/oop"),i=e("./text").Mode,s=e("./sas_highlight_rules").SASHighlightRules,o=e("./folding/cstyle").FoldMode,u=function(){this.HighlightRules=s,this.foldingRules=new o};r.inherits(u,i),function(){this.blockComment={start:"/*",end:"*/"},this.$id="ace/mode/sas"}.call(u.prototype),t.Mode=u})