ace.define("ace/mode/viml_highlight_rules",["require","exports","module","ace/lib/oop","ace/mode/text_highlight_rules"],function(e,t,n){"use strict";var r=e("../lib/oop"),i=e("./text_highlight_rules").TextHighlightRules,s=function(){this.$rules={start:[{include:"#comment"},{include:"#string_quoted_double"},{include:"#string_quoted_single"},{include:"#string_regex"},{include:"#inline_comment"},{include:"#number_int"},{include:"#number_hex"},{include:"#keyword"},{include:"#support_function"},{include:"#support_variable"},{include:"#support_type"},{include:"#function_params"},{include:"#function_definition"},{include:"#function_call"},{include:"#function"},{include:"#variable"},{include:"#expr"}],"#comment":[{token:"comment.line.quotes.viml",regex:'^\\s*".*$'}],"#expr":[{token:"storage.function.viml",regex:"\\|\\||&&|==(?:\\?|#)?|(?:!|>|<)=(?:#|\\?)?|(?:=|!)~(?:#|\\?)?|(?:>|<)(?:#|\\?)is|isnot|\\.|\\*|\\\\|%"}],"#function":[{token:"storage.function.viml",regex:"\\b(?:fu(?:n|nction)?|end(?:f|fu|fun|function)?)\\b"}],"#function_call":[{token:"support.function.any-method",regex:"(?:[sgbwtl]|)?:?[0-9a-zA-Z_#]+(?=\\()"}],"#function_definition":[{token:["meta.function.viml","storage.function.viml","meta.function.viml"],regex:"^(\\s*)(function)(\\s*!?\\s+)(?=(?:s:)?[0-9a-zA-Z_#]+\\s*\\()",push:[{token:"punctuation.definition.parameters.begin.viml",regex:"\\(",next:"pop"},{token:"entity.name.function.viml",regex:"(?:s:)?[0-9a-zA-Z_#]+"},{defaultToken:"meta.function.viml"}]}],"#function_params":[{token:"support.type.viml",regex:"-\\w+="}],"#inline_comment":[{token:["punctuation.definition.comment.vim","comment.line.quotes.viml"],regex:'(?!\\$)(")(?!\\{)(.*$)'}],"#keyword":[{token:"keyword.control.viml",regex:"\\b(?:if|while|for|return|end(?:if|for|while)?|au(?:g|group)|else(?:if|)?|do|in|:)\\b"}],"#number_hex":[{token:"constant.numeric.hex",regex:"#[0-9a-f]{6}"}],"#number_int":[{token:"constant.numeric.integer",regex:"-?\\d+"}],"#string_quoted_double":[{token:"string.quoted.double.viml",regex:'"(?:\\\\\\\\|\\\\"|[^$"])*"'}],"#string_quoted_single":[{token:"string.quoted.single.viml",regex:"'(?:\\\\\\\\|\\\\'|[^$'])*'"}],"#string_regex":[{token:"string.regexp.viml",regex:"/(?:\\\\\\\\|\\\\/|[^$/])*/"}],"#support_function":[{token:"support.function.viml",regex:"\\b(?:set(?:local|global)?|let|command|filetype|colorscheme|\\w*map|syn|exe(?:c|cute)?|ec(?:ho|)?|au(?:tocmd|)?)\\b"}],"#support_type":[{token:"support.type.viml",regex:"<.*?>"}],"#support_variable":[{token:"support.variable.viml",regex:"\\b(?:am(?:enu|)?|(?:hl|inc)?search|[Bb]uf(?:[Nn]ew[Ff]ile|[Rr]ead)?|[Ff]ile[Tt]ype)\\b"}],"#variable":[{token:"variable.other.viml",regex:"(?:[sSgGbBwWlLaAvV]:|@|$|&(?!&))\\w*"}]},this.normalizeRules()};s.metaData={fileTypes:["vim"],foldingStartMarker:"^(if|while|for|fu|function|augroup|aug)",foldingStopMarker:"(endif|endwhile|endfor|endf|endfunction|augroup\\.END|aug\\.END)$",name:"VimL",scopeName:"source.viml"},r.inherits(s,i),t.VimLHighlightRules=s}),ace.define("ace/mode/folding/cstyle",["require","exports","module","ace/lib/oop","ace/range","ace/mode/folding/fold_mode"],function(e,t,n){"use strict";var r=e("../../lib/oop"),i=e("../../range").Range,s=e("./fold_mode").FoldMode,o=t.FoldMode=function(e){e&&(this.foldingStartMarker=new RegExp(this.foldingStartMarker.source.replace(/\|[^|]*?$/,"|"+e.start)),this.foldingStopMarker=new RegExp(this.foldingStopMarker.source.replace(/\|[^|]*?$/,"|"+e.end)))};r.inherits(o,s),function(){this.foldingStartMarker=/(\{|\[)[^\}\]]*$|^\s*(\/\*)/,this.foldingStopMarker=/^[^\[\{]*(\}|\])|^[\s\*]*(\*\/)/,this.singleLineBlockCommentRe=/^\s*(\/\*).*\*\/\s*$/,this.tripleStarBlockCommentRe=/^\s*(\/\*\*\*).*\*\/\s*$/,this.startRegionRe=/^\s*(\/\*|\/\/)#?region\b/,this._getFoldWidgetBase=this.getFoldWidget,this.getFoldWidget=function(e,t,n){var r=e.getLine(n);if(this.singleLineBlockCommentRe.test(r)&&!this.startRegionRe.test(r)&&!this.tripleStarBlockCommentRe.test(r))return"";var i=this._getFoldWidgetBase(e,t,n);return!i&&this.startRegionRe.test(r)?"start":i},this.getFoldWidgetRange=function(e,t,n,r){var i=e.getLine(n);if(this.startRegionRe.test(i))return this.getCommentRegionBlock(e,i,n);var s=i.match(this.foldingStartMarker);if(s){var o=s.index;if(s[1])return this.openingBracketBlock(e,s[1],n,o);var u=e.getCommentFoldRange(n,o+s[0].length,1);return u&&!u.isMultiLine()&&(r?u=this.getSectionRange(e,n):t!="all"&&(u=null)),u}if(t==="markbegin")return;var s=i.match(this.foldingStopMarker);if(s){var o=s.index+s[0].length;return s[1]?this.closingBracketBlock(e,s[1],n,o):e.getCommentFoldRange(n,o,-1)}},this.getSectionRange=function(e,t){var n=e.getLine(t),r=n.search(/\S/),s=t,o=n.length;t+=1;var u=t,a=e.getLength();while(++t<a){n=e.getLine(t);var f=n.search(/\S/);if(f===-1)continue;if(r>f)break;var l=this.getFoldWidgetRange(e,"all",t);if(l){if(l.start.row<=s)break;if(l.isMultiLine())t=l.end.row;else if(r==f)break}u=t}return new i(s,o,u,e.getLine(u).length)},this.getCommentRegionBlock=function(e,t,n){var r=t.search(/\s*$/),s=e.getLength(),o=n,u=/^\s*(?:\/\*|\/\/|--)#?(end)?region\b/,a=1;while(++n<s){t=e.getLine(n);var f=u.exec(t);if(!f)continue;f[1]?a--:a++;if(!a)break}var l=n;if(l>o)return new i(o,r,l,t.length)}}.call(o.prototype)}),ace.define("ace/mode/viml",["require","exports","module","ace/lib/oop","ace/mode/text","ace/mode/viml_highlight_rules","ace/mode/folding/cstyle"],function(e,t,n){"use strict";var r=e("../lib/oop"),i=e("./text").Mode,s=e("./viml_highlight_rules").VimLHighlightRules,o=e("./folding/cstyle").FoldMode,u=function(){this.HighlightRules=s,this.foldingRules=new o};r.inherits(u,i),function(){this.$id="ace/mode/viml"}.call(u.prototype),t.Mode=u})